HDU - 2819 Swap(二分匹配)

题意:交换任意两行或两列,使主对角线全为1。

分析:

1、主对角线都为1,可知最终,第一行与第一列匹配,第二行与第二列匹配,……。

2、根据初始给定的矩阵,若Aij = 1,则说明第i行与第j列匹配,据此求最大匹配数cnt,若cnt==N,才可通过交换使主对角线都为1。

3、交换时,可只交换行或只交换列。如:只交换列,行不变(顺序为1,2,3,……,n),那么对于列,只需要根据选择排序,将每行一开始匹配的列的顺序最终也变成1,2,3,……,n即可,因为是选择排序,每次选择第i小的交换到第i个位置,因此最多只需要交换N次。

#include<cstdio>
#include<cstring>
#include<cstdlib>
#include<cctype>
#include<cmath>
#include<iostream>
#include<sstream>
#include<iterator>
#include<algorithm>
#include<string>
#include<vector>
#include<set>
#include<map>
#include<stack>
#include<deque>
#include<queue>
#include<list>
#define lowbit(x) (x & (-x))
const double eps = 1e-9;
inline int dcmp(double a, double b){
    if(fabs(a - b) < eps) return 0;
    return a > b ? 1 : -1;
}
typedef long long LL;
typedef unsigned long long ULL;
const int INT_INF = 0x3f3f3f3f;
const int INT_M_INF = 0x7f7f7f7f;
const LL LL_INF = 0x3f3f3f3f3f3f3f3f;
const LL LL_M_INF = 0x7f7f7f7f7f7f7f7f;
const int dr[] = {0, 0, -1, 1, -1, -1, 1, 1};
const int dc[] = {-1, 1, 0, 0, -1, 1, -1, 1};
const int MOD = 1e9 + 7;
const double pi = acos(-1.0);
const int MAXN = 100 + 10;
const int MAXT = 1000 + 10;
using namespace std;
int a[MAXN][MAXN];
bool used[MAXN];
int match[MAXN];
vector<pair<int, int> > v;
int N;
bool dfs(int x){
    for(int i = 1; i <= N; ++i){
        if(a[x][i] && !used[i]){
            used[i] = true;
            if(match[i] == -1 || dfs(match[i])){
                match[i] = x;
                return true;
            }
        }
    }
    return false;
}
int hungary(){
    int cnt = 0;
    for(int i = 1; i <= N; ++i){
        memset(used, false, sizeof used);
        if(dfs(i)) ++cnt;
    }
    return cnt;
}
int main(){
    while(scanf("%d", &N) == 1){
        memset(match, -1, sizeof match);
        v.clear();
        for(int i = 1; i <= N; ++i){
            for(int j = 1; j <= N; ++j){
                scanf("%d", &a[i][j]);
            }
        }
        int cnt = hungary();
        if(cnt != N){
            printf("-1\n");
            continue;
        }
        for(int i = 1; i <= N; ++i){
            int tmp = i;
            for(int j = i + 1; j <= N; ++j){
                if(match[tmp] > match[j]) tmp = j;
            }
            if(tmp == i) continue;
            v.push_back(pair<int, int>(i, tmp));
            swap(match[i], match[tmp]);
        }
        int len = v.size();
        printf("%d\n", len);
        for(int i = 0; i < len; ++i){
            printf("C %d %d\n", v[i].first, v[i].second);
        }
    }
    return 0;
}

  

时间: 2024-10-07 09:09:03

HDU - 2819 Swap(二分匹配)的相关文章

HDU 2819 Swap (二分匹配+破输出)

题意:给定上一个01矩阵,让你变成一个对角全是 1 的矩阵. 析:二分匹配,把行和列看成两个集合,用匈牙利算法就可以解决,主要是在输出解,在比赛时一紧张不知道怎么输出了. 输出应该是要把 match[i] = i 这样的输出,然后再改掉后面那个,真是个大傻逼输出,气死了..... 代码如下: #pragma comment(linker, "/STACK:1024000000,1024000000") #include <cstdio> #include <strin

HDU 2819 — Swap 二分匹配

Swap Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 2174    Accepted Submission(s): 774Special Judge Problem Description Given an N*N matrix with each entry equal to 0 or 1. You can swap any tw

hdu 2819 Swap(二分图匹配)

hdu 2819 Swap Description Given an N*N matrix with each entry equal to 0 or 1. You can swap any two rows or any two columns. Can you find a way to make all the diagonal entries equal to 1? Input There are several test cases in the input. The first li

Hdu 1045 二分匹配

题目链接 Fire Net Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 6282    Accepted Submission(s): 3551 Problem Description Suppose that we have a square city with straight streets. A map of a city i

hdu 3081 【二分匹配+并查集+删边||最大路+并查集+二分枚举】

Marriage Match II Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 2307    Accepted Submission(s): 792 Problem Description Presumably, you all have known the question of stable marriage match. A

hdu 2819 Swap【完美二分匹配】

Swap Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 2514    Accepted Submission(s): 900 Special Judge Problem Description Given an N*N matrix with each entry equal to 0 or 1. You can swap any

E - Swap - hdu 2819(简单二分图匹配)

题意:如果可以交换行列,问主对角线能不能全为1 分析:要想主对角线全为1很明显要有N个行列不想同的点就行了,可以用二分图匹配计算出来多能有几个.如果小与N就不能.输出要是对的就行,不必和答案一样 ************************************************************************ #include<stdio.h>#include<algorithm>#include<string.h>using namesp

Hdu 1281 棋盘游戏 (二分匹配)

题目链接: Hdu 1281 棋盘游戏 题目描述: 题目汉语,只说一点,国际象棋中车的攻击范围就像n皇后问题中的皇后一样,同行和同列的车都会相互攻击. 解题思路: 求出来的最大匹配数目==最多能放几个车.计算有几个格子是重要点的时候只需要算出最大的匹配数目,然后枚举每个点不能放置棋子时候的最大匹配数目.最大匹配数目小于原匹配数目的时候,当前枚举点就是重要点. 1 #include <cstdio> 2 #include <cstring> 3 #include <iostre

hdu 2119 Matrix(二分匹配)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2119 Matrix Time Limit: 5000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 2205    Accepted Submission(s): 975 Problem Description Give you a matrix(only contains